// name   : FileHandlerBase.cs
// author : Harald Maier
// date   : 17.10.2003
//
//
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version.                                   

using System;
using System.IO;
using System.Collections;

using SoaringDotNET.GUI;
using SoaringDotNET.Data;

namespace SoaringDotNET.FileFormats
{
	/// <summary>
	/// 
	/// </summary>
	public abstract class FileHandlerBase
	{
		public FileHandlerBase()
		{
			// 
			// TODO: Add constructor logic here
			//
		}

        public virtual void Load(StreamReader f, WaypointCatalog c){}
        public virtual void Save(StreamWriter f, WaypointCatalog c){}

        public virtual void Load(StreamReader f, ArrayList tasks){}
        public virtual void Save(StreamWriter f, ArrayList tasks){}

        public virtual void Load(StreamReader f, WaypointCatalog c, ArrayList tasks){}
        public virtual void Save(StreamWriter f, WaypointCatalog c, ArrayList tasks){}

        public virtual string BuildLine(WayPoint wp){return "";}
        public virtual WayPoint ParseLine(string line){return null;}
    }
}
